package  
{
	/**
	 * ...
	 * @author Guchan Alkan
	 */
	public class MergeSort extends Sort
	{
		
		public function MergeSort() 
		{
			
		}
		
		public override function ascending(array:Array):Array
		{
			var n:int = array.length;
			if (n <= 1)
			{
				return array;
			}
			
			var left:Array = [];
			var right:Array = [];
			var middle:int = n / 2;
			
			for (var i:int = 0; i < middle; i++) 
			{
				left.push(array[i]);
			}
			for (var j:int = middle; j < n; j++) 
			{
				right.push(array[j]);
			}
			
			left = ascending(left);
			right = ascending(right);
			
			return merge(left, right);
		}
		
		private function merge(left:Array, right:Array):Array
		{
			var result:Array = [];
			
			while (left.length > 0 || right.length > 0)
			{
				if (left.length > 0 && right.length > 0)
				{
					if (left[0] <= right[0])
					{
						result.push(left[0]);
						left.shift();
					}
					else
					{
						result.push(right[0]);
						right.shift();
					}
				}
				else if (left.length > 0)
				{
					result = result.concat(left);
					left = [];
				}
				else if (right.length > 0)
				{
					result = result.concat(right);
					right = [];
				}
			}
			
			return result;
		}
		
	}

}