package  
{
	/**
	 * ...
	 * @author Guchan Alkan
	 */
	public class HeapSort extends Sort
	{
		
		public function HeapSort() 
		{
			
		}
		
		public override function ascending(array:Array):Array
		{
			var n:int = array.length;
			var i:int;
			var temp:int;
			
			for (i = n / 2; i >= 0; i--) 
			{
				siftDown(array, i, n - 1);
			}
			
			for (i = n - 1; i >= 1; i--)
			{
				temp = array[0];
				array[0] = array[i];
				array[i] = temp;
				
				siftDown(array, 0, i - 1);
			}
			return array;
		}
		
		private function siftDown(array:Array, root:int, bottom:int):void
		{
			var maxChild:int = root * 2 + 1;
			
			if (maxChild < bottom)
			{
				var otherChild:int = maxChild + 1;
				maxChild = (array[otherChild] > array[maxChild]) ? otherChild : maxChild;
			}
			else
			{
				if (maxChild > bottom) return;
			}
			
			if (array[root] >= array[maxChild])
			{
				return;
			}
			
			var temp:int = array[root];
			array[root] = array[maxChild];
			array[maxChild] = temp;
			
			siftDown(array, maxChild, bottom);
		}
		
	}

}